//
//  RootViewController.m
//  BasicTable
//
//  Created by DuYabo on 11-6-12.
//  Copyright 2011 Mobroad. All rights reserved.
//

#import "RootViewController.h"
#import "User.h"
#import "UserEditViewController.h"


@implementation RootViewController

@synthesize users;
@synthesize userEditViewController;
@synthesize editingUser;
@synthesize nibLoadedCell;
@synthesize sortControl;


-(IBAction)handleAddTapped {
	User *tempUser=[[User alloc] init];
	editingUser=tempUser;
	userEditViewController.user=editingUser;
	[self.navigationController pushViewController:userEditViewController animated:YES];
	
	[users addObject:tempUser];
	NSIndexPath *tempUserPath=[NSIndexPath indexPathForRow:[users count]-1 inSection:0];
	NSArray *tempUserPaths=[NSArray arrayWithObject:tempUserPath];
	[self.tableView insertRowsAtIndexPaths:tempUserPaths withRowAnimation:NO];
	[tempUser release];
}

-(void)sortUsersArray {
	NSSortDescriptor *sorter;
	switch (sortControl.selectedSegmentIndex) {
		case 0:
			sorter=[[NSSortDescriptor alloc] initWithKey:@"name" ascending:YES];
			NSLog(@"1");
			break;
		case 1:
			sorter=[[NSSortDescriptor alloc] initWithKey:@"name" ascending:NO];
			NSLog(@"2");
			break;
		case 2:
			sorter=[[NSSortDescriptor alloc] initWithKey:@"salary" ascending:YES];
			NSLog(@"3");
			break;
	}
	NSArray *sortDescriptors=[NSArray arrayWithObject:sorter];
	[users sortUsingDescriptors:sortDescriptors];
	[sorter release];
}

-(IBAction)handleSortChanged {
	NSLog(@"%@",users);
	[self sortUsersArray];
	[self.tableView reloadData];
}



#pragma mark -
#pragma mark View lifecycle


- (void)viewDidLoad {
    [super viewDidLoad];

    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    self.navigationItem.leftBarButtonItem = self.editButtonItem;
	
	users=[[NSMutableArray alloc] init];
	User *user=[[User alloc] initWithName:@"Du Yabo" title:@"CTO" salary:[NSNumber numberWithInt:1000]];
	[users	addObject:user];
	[user release];
	
}



- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
	if(editingUser){
		NSIndexPath *updatedPath=[NSIndexPath indexPathForRow:[users indexOfObject:editingUser]inSection:0];
		NSArray *updatePaths=[NSArray arrayWithObject:updatedPath];
		[self.tableView reloadRowsAtIndexPaths:updatePaths withRowAnimation:NO];
		editingUser=nil;
	}
	[self sortUsersArray];
	[self.tableView reloadData];
}

/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
 // Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations.
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
 */


#pragma mark -
#pragma mark Table view data source

// Customize the number of sections in the table view.
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [users count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        //cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
		[[NSBundle mainBundle] loadNibNamed:@"UserTableCell" owner:self options:NULL];
		cell=nibLoadedCell;
    }
    
	// Configure the cell.
	/*User *user=[users objectAtIndex:indexPath.row];
	cell.textLabel.text=user.name;*/
	
	User *newUser=[users objectAtIndex:indexPath.row];
	UILabel *nameLabel=(UILabel *)[cell viewWithTag:1];
	nameLabel.text=newUser.name;
	UILabel *titleLabel=(UILabel *)[cell viewWithTag:2];
	titleLabel.text=newUser.title;
	UILabel *salaryLabel=(UILabel *)[cell viewWithTag:3];
	NSNumberFormatter *formatter=[[NSNumberFormatter alloc] init];
	[formatter setNumberStyle:NSNumberFormatterCurrencyStyle];
	salaryLabel.text=[formatter stringFromNumber:newUser.salary];
	[formatter release];

    return cell;
}



// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}




// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source.
		[users removeObjectAtIndex:indexPath.row];
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    } 
	/*
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view.
    }  */ 
}



/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


#pragma mark -
#pragma mark Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    
	/*
	 <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
	 [self.navigationController pushViewController:detailViewController animated:YES];
	 [detailViewController release];
	 */
	
	editingUser=[users objectAtIndex:indexPath.row];
	self.userEditViewController.user=editingUser;
	[self.navigationController pushViewController:self.userEditViewController animated:YES];
	
}


#pragma mark -
#pragma mark Memory management

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Relinquish ownership any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    // Relinquish ownership of anything that can be recreated in viewDidLoad or on demand.
    // For example: self.myOutlet = nil;
}


- (void)dealloc {
	[users release];
    [super dealloc];
}


@end

